/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#include <soprano/soprano.h>

#include "contact.h"

#include "attendee.h"
#include "dataobject.h"
#include "contact.h"
#include "role.h"
#include "attendeeororganizer.h"
#include "message.h"
#include "contactgroup.h"
#include "informationelement.h"
#include "email.h"

#include <QtCore/QDateTime>
#include <QtCore/QDate>
#include <QtCore/QTime>

NepomukFast::Contact::Contact( const QUrl &uri, const QUrl &graphUri )
  : Role( uri, graphUri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#Contact", QUrl::StrictMode) )
{
}

NepomukFast::Contact::Contact( const QUrl& uri, const QUrl& graphUri, const QUrl& type )
  : Role( uri, graphUri, type )
{
}

void NepomukFast::Contact::setKeys( const QList<NepomukFast::DataObject>& value )
{
    for( QList<DataObject>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#key"), (*it).uri() );
    }
}

void NepomukFast::Contact::addKey( const NepomukFast::DataObject& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#key"), value.uri() );
}

QUrl NepomukFast::Contact::keyUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#key");
}

void NepomukFast::Contact::setContactUIDs( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#contactUID"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Contact::addContactUID( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#contactUID"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Contact::contactUIDUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#contactUID");
}

void NepomukFast::Contact::setLocations( const QList<NepomukFast::Resource>& value )
{
    for( QList<Resource>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasLocation"), (*it).uri() );
    }
}

void NepomukFast::Contact::addLocation( const NepomukFast::Resource& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasLocation"), value.uri() );
}

QUrl NepomukFast::Contact::locationUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasLocation");
}

void NepomukFast::Contact::setNicknames( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nickname"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Contact::addNickname( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nickname"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Contact::nicknameUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nickname");
}

void NepomukFast::Contact::setNotes( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#note"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Contact::addNote( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#note"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Contact::noteUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#note");
}

void NepomukFast::Contact::setRepresentatives( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#representative"), (*it).uri() );
    }
}

void NepomukFast::Contact::addRepresentative( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#representative"), value.uri() );
}

QUrl NepomukFast::Contact::representativeUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#representative");
}

void NepomukFast::Contact::setFullname( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#fullname"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Contact::fullnameUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#fullname");
}

void NepomukFast::Contact::setPhotos( const QList<NepomukFast::DataObject>& value )
{
    for( QList<DataObject>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#photo"), (*it).uri() );
    }
}

void NepomukFast::Contact::addPhoto( const NepomukFast::DataObject& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#photo"), value.uri() );
}

QUrl NepomukFast::Contact::photoUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#photo");
}

void NepomukFast::Contact::setBirthDate( const QDate& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#birthDate"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Contact::birthDateUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#birthDate");
}

void NepomukFast::Contact::setBelongsToGroups( const QList<NepomukFast::ContactGroup>& value )
{
    for( QList<ContactGroup>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#belongsToGroup"), (*it).uri() );
    }
}

void NepomukFast::Contact::addBelongsToGroup( const NepomukFast::ContactGroup& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#belongsToGroup"), value.uri() );
}

QUrl NepomukFast::Contact::belongsToGroupUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#belongsToGroup");
}

void NepomukFast::Contact::setSounds( const QList<NepomukFast::DataObject>& value )
{
    for( QList<DataObject>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#sound"), (*it).uri() );
    }
}

void NepomukFast::Contact::addSound( const NepomukFast::DataObject& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#sound"), value.uri() );
}

QUrl NepomukFast::Contact::soundUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#sound");
}

NepomukFast::Role NepomukFast::Contact::toRole() const
{
    return NepomukFast::Role( uri(), graphUri() );
}

NepomukFast::InformationElement NepomukFast::Contact::toInformationElement() const
{
    return NepomukFast::InformationElement( uri(), graphUri() );
}


