/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _EVENT_H_
#define _EVENT_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class UnionOfEventTodo;
    class UnionOfTimezoneObservanceEventFreebusyJournalTimezoneTodo;
    class InformationElement;
    class UnionOfEventJournalTodo;
    class UnionOfTimezoneObservanceEventJournalTimezoneTodo;
    class UnionOfAlarmEventTodo;
    class UnionOfAlarmEventFreebusyJournalTodo;
    class UnionOfEventFreebusy;
    class UnionOfEventFreebusyJournalTodo;
    class EventStatus;
    class UnionOfTimezoneObservanceEventFreebusyTimezoneTodo;
    class UnionOfAlarmEventFreebusyTodo;
    class TimeTransparency;
    class UnionOfAlarmEventJournalTodo;
    class UnionOfEventJournalTimezoneTodo;

}

#include "unionofalarmeventtodo.h"

namespace NepomukFast {

    /**
     * Provide a grouping of component properties that describe an 
     * event. 
     */
    class Event : public UnionOfAlarmEventTodo
    {
    public:
        /**
         * Create a new empty and invalid Event instance
         */
        Event( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'transp'. Defines whether an event is transparent 
         * or not to busy time searches. Inspired by RFC 2445 sec.4.8.2.7. 
         * Values for this property can be chosen from a limited vocabulary. 
         * To express this a TimeTransparency class has been introduced. 
         */
        void setTransps( const QList<TimeTransparency>& value );

        /**
         * Add a value to property 'transp'. Defines whether an event is 
         * transparent or not to busy time searches. Inspired by RFC 2445 
         * sec.4.8.2.7. Values for this property can be chosen from a limited 
         * vocabulary. To express this a TimeTransparency class has been 
         * introduced. 
         */
        void addTransp( const TimeTransparency& value );

        /**
         * \return The URI of the property 'transp'. 
         */
        static QUrl transpUri();

        /**
         * Set property 'eventStatus'. Defines the overall status or 
         * confirmation for an Event. Based on the STATUS property defined 
         * in RFC 2445 sec. 4.8.1.11. 
         */
        void setEventStatuses( const QList<EventStatus>& value );

        /**
         * Add a value to property 'eventStatus'. Defines the overall 
         * status or confirmation for an Event. Based on the STATUS property 
         * defined in RFC 2445 sec. 4.8.1.11. 
         */
        void addEventStatus( const EventStatus& value );

        /**
         * \return The URI of the property 'eventStatus'. 
         */
        static QUrl eventStatusUri();

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfTimezoneObservanceEventFreebusyTimezoneTodo toUnionOfTimezoneObservanceEventFreebusyTimezoneTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfAlarmEventFreebusyJournalTodo toUnionOfAlarmEventFreebusyJournalTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfEventFreebusy toUnionOfEventFreebusy() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfAlarmEventJournalTodo toUnionOfAlarmEventJournalTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfEventFreebusyJournalTodo toUnionOfEventFreebusyJournalTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        InformationElement toInformationElement() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfEventJournalTodo toUnionOfEventJournalTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfTimezoneObservanceEventJournalTimezoneTodo toUnionOfTimezoneObservanceEventJournalTimezoneTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfTimezoneObservanceEventFreebusyJournalTimezoneTodo toUnionOfTimezoneObservanceEventFreebusyJournalTimezoneTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfEventJournalTimezoneTodo toUnionOfEventJournalTimezoneTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfAlarmEventFreebusyTodo toUnionOfAlarmEventFreebusyTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfEventTodo toUnionOfEventTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfAlarmEventTodo toUnionOfAlarmEventTodo() const;



    protected:
        Event( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
