/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _IMACCOUNT_H_
#define _IMACCOUNT_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class Role;

}

#include "contactmedium.h"

namespace NepomukFast {

    /**
     * An account in an Instant Messaging system. 
     */
    class IMAccount : public ContactMedium
    {
    public:
        /**
         * Create a new empty and invalid IMAccount instance
         */
        IMAccount( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'imStatus'. Current status of the given IM account. 
         * Values for this property may include 'Online', 'Offline', 
         * 'Do not disturb' etc. The exact choice of them is unspecified. 
         */
        void setImStatus( const QString& value );

        /**
         * \return The URI of the property 'imStatus'. 
         */
        static QUrl imStatusUri();

        /**
         * Set property 'imID'. Identifier of the IM account. Examples 
         * of such identifier might include ICQ UINs, Jabber IDs, Skype 
         * names etc. 
         */
        void setImIDs( const QStringList& value );

        /**
         * Add a value to property 'imID'. Identifier of the IM account. 
         * Examples of such identifier might include ICQ UINs, Jabber 
         * IDs, Skype names etc. 
         */
        void addImID( const QString& value );

        /**
         * \return The URI of the property 'imID'. 
         */
        static QUrl imIDUri();

        /**
         * Set property 'imNickname'. A nickname attached to a particular 
         * IM Account. 
         */
        void setImNicknames( const QStringList& value );

        /**
         * Add a value to property 'imNickname'. A nickname attached to 
         * a particular IM Account. 
         */
        void addImNickname( const QString& value );

        /**
         * \return The URI of the property 'imNickname'. 
         */
        static QUrl imNicknameUri();

        /**
         * Set property 'imAccountType'. Type of the IM account. This 
         * may be the name of the service that provides the IM functionality. 
         * Examples might include Jabber, ICQ, MSN etc 
         */
        void setImAccountTypes( const QStringList& value );

        /**
         * Add a value to property 'imAccountType'. Type of the IM account. 
         * This may be the name of the service that provides the IM functionality. 
         * Examples might include Jabber, ICQ, MSN etc 
         */
        void addImAccountType( const QString& value );

        /**
         * \return The URI of the property 'imAccountType'. 
         */
        static QUrl imAccountTypeUri();

        /**
         * Set property 'imStatusMessage'. A feature common in most IM 
         * systems. A message left by the user for all his/her contacts 
         * to see. 
         */
        void setImStatusMessages( const QStringList& value );

        /**
         * Add a value to property 'imStatusMessage'. A feature common 
         * in most IM systems. A message left by the user for all his/her 
         * contacts to see. 
         */
        void addImStatusMessage( const QString& value );

        /**
         * \return The URI of the property 'imStatusMessage'. 
         */
        static QUrl imStatusMessageUri();



    protected:
        IMAccount( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
