/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _TRIGGER_H_
#define _TRIGGER_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class TriggerRelation;
    class UnionOfAlarmEventTodo;

}

#include "resource.h"

namespace NepomukFast {

    /**
     * An alarm trigger. This class has been created to serve as the 
     * range of ncal:trigger property. See the documentation for 
     * ncal:trigger for more details. 
     */
    class Trigger : public NepomukFast::Resource
    {
    public:
        /**
         * Create a new empty and invalid Trigger instance
         */
        Trigger( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'related'. To specify the relationship of the 
         * alarm trigger with respect to the start or end of the calendar 
         * component. Inspired by RFC 2445 4.2.14. The RFC has specified 
         * two possible values for this property ('START' and 'END') they 
         * have been expressed as instances of the TriggerRelation class. 
         */
        void setRelateds( const QList<TriggerRelation>& value );

        /**
         * Add a value to property 'related'. To specify the relationship 
         * of the alarm trigger with respect to the start or end of the calendar 
         * component. Inspired by RFC 2445 4.2.14. The RFC has specified 
         * two possible values for this property ('START' and 'END') they 
         * have been expressed as instances of the TriggerRelation class. 
         */
        void addRelated( const TriggerRelation& value );

        /**
         * \return The URI of the property 'related'. 
         */
        static QUrl relatedUri();

        /**
         * Set property 'triggerDateTime'. The exact date and time of 
         * the trigger. This property has been created to express the VALUE=DATE, 
         * and VALUE=DATE-TIME parameters of the TRIGGER property. See 
         * the documentation for ncal:trigger for more details 
         */
        void setTriggerDateTimes( const QList<QDateTime>& value );

        /**
         * Add a value to property 'triggerDateTime'. The exact date and 
         * time of the trigger. This property has been created to express 
         * the VALUE=DATE, and VALUE=DATE-TIME parameters of the TRIGGER 
         * property. See the documentation for ncal:trigger for more 
         * details 
         */
        void addTriggerDateTime( const QDateTime& value );

        /**
         * \return The URI of the property 'triggerDateTime'. 
         */
        static QUrl triggerDateTimeUri();



    protected:
        Trigger( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
