/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _UNIONOFEVENTFREEBUSYJOURNALTODO_H_
#define _UNIONOFEVENTFREEBUSYJOURNALTODO_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class Organizer;
    class RequestStatus;
    class Resource;

}

#include "unionparentclass.h"

namespace NepomukFast {


    class UnionOfEventFreebusyJournalTodo : public UnionParentClass
    {
    public:
        /**
         * Create a new empty and invalid UnionOfEventFreebusyJournalTodo instance
         */
        UnionOfEventFreebusyJournalTodo( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'uid'. This property defines the persistent, 
         * globally unique identifier for the calendar component. Inspired 
         * by the RFC 2445 sec 4.8.4.7 
         */
        void setUids( const QStringList& value );

        /**
         * Add a value to property 'uid'. This property defines the persistent, 
         * globally unique identifier for the calendar component. Inspired 
         * by the RFC 2445 sec 4.8.4.7 
         */
        void addUid( const QString& value );

        /**
         * \return The URI of the property 'uid'. 
         */
        static QUrl uidUri();

        /**
         * Set property 'dtstamp'. The property indicates the date/time 
         * that the instance of the iCalendar object was created. Inspired 
         * by RFC 2445 sec. 4.8.7.1. Note that the RFC allows ONLY UTC values 
         * for this property. 
         */
        void setDtstamps( const QList<QDateTime>& value );

        /**
         * Add a value to property 'dtstamp'. The property indicates the 
         * date/time that the instance of the iCalendar object was created. 
         * Inspired by RFC 2445 sec. 4.8.7.1. Note that the RFC allows ONLY 
         * UTC values for this property. 
         */
        void addDtstamp( const QDateTime& value );

        /**
         * \return The URI of the property 'dtstamp'. 
         */
        static QUrl dtstampUri();

        /**
         * Set property 'contact'. The property is used to represent contact 
         * information or alternately a reference to contact information 
         * associated with the calendar component. Inspired by RFC 2445 
         * sec. 4.8.4.2 with the following reservations: the LANGUAGE 
         * parameter has been discarded. Please use xml:lang literals 
         * to express language. For the ALTREP parameter use the contactAltRep 
         * property.RFC doesn't define any format for the string. 
         */
        void setContacts( const QStringList& value );

        /**
         * Add a value to property 'contact'. The property is used to represent 
         * contact information or alternately a reference to contact 
         * information associated with the calendar component. Inspired 
         * by RFC 2445 sec. 4.8.4.2 with the following reservations: the 
         * LANGUAGE parameter has been discarded. Please use xml:lang 
         * literals to express language. For the ALTREP parameter use 
         * the contactAltRep property.RFC doesn't define any format 
         * for the string. 
         */
        void addContact( const QString& value );

        /**
         * \return The URI of the property 'contact'. 
         */
        static QUrl contactUri();

        /**
         * Set property 'url'. This property defines a Uniform Resource 
         * Locator (URL) associated with the iCalendar object. Inspired 
         * by the RFC 2445 sec. 4.8.4.6. Original range had been specified 
         * as URI. 
         */
        void setUrls( const QList<Resource>& value );

        /**
         * Add a value to property 'url'. This property defines a Uniform 
         * Resource Locator (URL) associated with the iCalendar object. 
         * Inspired by the RFC 2445 sec. 4.8.4.6. Original range had been 
         * specified as URI. 
         */
        void addUrl( const Resource& value );

        /**
         * \return The URI of the property 'url'. 
         */
        static QUrl urlUri();

        /**
         * Set property 'requestStatus'. This property defines the status 
         * code returned for a scheduling request. Inspired by RFC 2445 
         * sec. 4.8.8.2. Original value of this property was a four-element 
         * structure. The RequestStatus class has been introduced to 
         * express it. In RFC 2445 this property could have the LANGUAGE 
         * parameter. This has been discarded in this ontology. Use xml:lang 
         * literals to express it if necessary. 
         */
        void setRequestStatuses( const QList<RequestStatus>& value );

        /**
         * Add a value to property 'requestStatus'. This property defines 
         * the status code returned for a scheduling request. Inspired 
         * by RFC 2445 sec. 4.8.8.2. Original value of this property was 
         * a four-element structure. The RequestStatus class has been 
         * introduced to express it. In RFC 2445 this property could have 
         * the LANGUAGE parameter. This has been discarded in this ontology. 
         * Use xml:lang literals to express it if necessary. 
         */
        void addRequestStatus( const RequestStatus& value );

        /**
         * \return The URI of the property 'requestStatus'. 
         */
        static QUrl requestStatusUri();

        /**
         * Set property 'organizer'. The property defines the organizer 
         * for a calendar component. Inspired by RFC 2445 sec. 4.8.4.3. 
         * Originally this property accepted many parameters. The Organizer 
         * class has been introduced to express them all. Note that NCAL 
         * is aligned with NCO. The actual value (of the CAL-ADDRESS type) 
         * is expressed as an instance of nco:Contact. Remember that the 
         * CN parameter has been removed from NCAL. Instead that value 
         * should be expressed using nco:fullname property of the above 
         * mentioned nco:Contact instance. 
         */
        void setOrganizers( const QList<Organizer>& value );

        /**
         * Add a value to property 'organizer'. The property defines the 
         * organizer for a calendar component. Inspired by RFC 2445 sec. 
         * 4.8.4.3. Originally this property accepted many parameters. 
         * The Organizer class has been introduced to express them all. 
         * Note that NCAL is aligned with NCO. The actual value (of the CAL-ADDRESS 
         * type) is expressed as an instance of nco:Contact. Remember 
         * that the CN parameter has been removed from NCAL. Instead that 
         * value should be expressed using nco:fullname property of the 
         * above mentioned nco:Contact instance. 
         */
        void addOrganizer( const Organizer& value );

        /**
         * \return The URI of the property 'organizer'. 
         */
        static QUrl organizerUri();

        /**
         * Set property 'contactAltRep'. Alternate representation 
         * of the contact property. Introduced to cover the ALTREP parameter 
         * of the CONTACT property. See documentation of ncal:contact 
         * for details. 
         */
        void setContactAltReps( const QList<Resource>& value );

        /**
         * Add a value to property 'contactAltRep'. Alternate representation 
         * of the contact property. Introduced to cover the ALTREP parameter 
         * of the CONTACT property. See documentation of ncal:contact 
         * for details. 
         */
        void addContactAltRep( const Resource& value );

        /**
         * \return The URI of the property 'contactAltRep'. 
         */
        static QUrl contactAltRepUri();



    protected:
        UnionOfEventFreebusyJournalTodo( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
